4.20.0 (2024-12-15)
======



4.19.3 (2024-12-01)
======
- xdg-cache: Fix string leak in xdg_cache_cache_cleanup
- tumblerd: Fix string leaks in tumbler_manager_directory_changed
- Translation Updates:
  Czech, Latvian, Telugu

4.19.2 (2024-11-01)
======
- build: Bump requirements for Xfce 4.20
- Apply .clang-format file
- Sort includes
- tumbler: Add missing include guards
- clang-format: Add file
- plugins: Do not use g_file_is_native() to check for a valid path
- gepub-thumbnailer: Emit error signal if file location is unsupported
- gepub-thumbnailer: Fix create_from_mime()
- gcc-analyzer: Fix -Wanalyzer-fd-leak
- scan-build: Add false positive file
- build: Use AM_DISTCHECK_CONFIGURE_FLAGS
- xdg-cache: Fix and optimize xdg_cache_cache_is_thumbnail()
- Do not use g_log_set_always_fatal()
- Translation Updates:
  Polish

4.19.1 (2024-02-05)
======
- Update copyright year
- gepub-thumbnailer: Return if GBytes buffer is NULL
- build: Search for bind_textdomain_codeset in libintl too
- Disambiguate thumbnailer signals
- scheduler: Fix ready/error signal forwarding
- desktop-thumbnailer: Use empty path to build cmdline if it is null
- Update spec link in README
- xdg-cache: Fix temporary file management when saving thumbnail
- Add icon at 64px, clean up SVG metadata
- I18n: Update po/LINGUAS list
- I18n: Update po/LINGUAS list
- Translation Updates:
  Catalan, Czech, Greek

4.19.0 (2023-04-17)
======
- Fix memory leak in jpeg-thumbnailer
- Fix memory leak in cover-thumbnailer
- build: Use m4_defined min versions and cleanup
- build: Use XDT_CHECK_PACKAGE_BINARY
- build: Use XDT_VERSION_INIT
- build: Switch from intltool to gettext
- Fix previous commit
- cover-thumbnailer: Fix deprecation warning
- cleanup: tumblerd: Use G_DECLARE_FINAL_TYPE and friends
- cleanup: tumbler: Use G_DECLARE_FINAL_TYPE and G_DECLARE_INTERFACE
- cleanup: plugins: Use G_DECLARE_FINAL_TYPE for plugins
- cleanup: plugins: Use G_DECLARE_FINAL_TYPE for providers
- build: Let xdt-depends.m4 macros set GLib macros
- Translation Updates:
  English (Canada), Greek, Korean, Portuguese

4.18.0 (2022-12-15)
======
- build: Bump requirements for Xfce 4.18
- tumbler.rc: Fix typo in explanatory comment
- Translation Updates:
  Hungarian

4.17.3 (2022-10-31)
======
- Code Refactoring:
  - cleanup: Do not set and free a GError unnecessarily

- Bug Fixes:
  - desktop-thumbnailer: Avoid recursion (Fixes #67)
  - desktop-thumbnailer: allocate/free memory at the right level
  - Allow libgepub 0.7 as well
  - docs: Fix broken links
  - docs: Remove pointless sections
  - gst-thumbnailer: Add mime type check (Fixes #65)
  - desktop-thumbnailer: Guard against null path

- Translation Updates:
  Galician, Kazakh, Russian

4.17.2 (2022-06-19)
======
- Bug Fixes:
  - Yet another fix to the modification time storage format

4.17.1 (2022-06-12)
======
- New Features:
  - Allow to choose an alternative service name prefix (!21)

- Performance Improvement:
  - scheduler: Enable multi-threading (#1)

- Bug Fixes:
  - Store modification time in locale independent format
  - desktop-thumbnailer: Delete temp file at the same level it was created (#57)
  - i18n: Add missing initialization
  - Fix missing mutex unlock in group scheduler (#56)
  - Build: Check for best possible grep, egrep, sed

- Translation Updates:
  Basque, Danish, English (United Kingdom), Greek, Malay, Portuguese
  (Brazil), Romanian, Russian, Serbian, Slovenian, Ukrainian

4.17.0 (2022-01-01)
======
- Dependency Changes:
  - GLib >= 2.56.0
  - gdk-pixbuf >= 2.36.2
  - libxfce4util >= 4.17.1

- New Features:
  - Add support for thumbnail size x-large and xx-large (#51)
  - desktop-thumbnailer: Allow to override configuration in desktop files (#52)
  - desktop-thumbnailer: Allow for thumbnailer override (#53)
  - Try all available thumbnailers before declaring failure (#50)
  - Add a corresponding systemd user service for the D-Bus session services (#14)
  - Support shared thumbnail repositories of the freedesktop.org thumbnail spec

- Performance Improvement:
  - pixbuf-thumbnailer: Stop animated image loading at first frame (#48)
  - pixbuf-thumbnailer: Increase loader buffer size (!19)

- Code Refactoring:
  - Cleanup: Avoid code duplication
  - Use GLib structured logging
  - Debug: Add some config-file-related messages (#23)
  - Error handling: Fit to the spec and complete message if needed (#49)
  - Debug: Add or adjust some traces and dumps
  - Debug: Convert dump functions to `GString, g_debug()`
  - Debug: Prefer runtime to compile-time check for logging
  - Cleanup: Use `g_file_peek_path()` when appropriate
  - Cleanup: Remove deprecated GNOME build and TODO file
  - Do not translate warning messages
  - Define error messages in `tumbler/tumbler-error.h`
  - poppler-thumbnailer: Fix deprecation warning
  - ffmpeg-thumbnailer: Fix deprecation warning
  - Fix warnings from scan-build (Clang 13.0)
  - Fix `-Wclobbered` compilation warnings
  - Use GLIB_VERSION_MIN/MAX_REQUIRED/ALLOWED
  - Remove TUMBLER_ADD_INTERFACE (!16)
  - Fix compilation warnings (!16)
  - autoconf: Some updates (!16)
  - Remove GSourceFunc casts (!13)

- Bug Fixes:
  - gepub-thumbnailer: Add missing sanity check
  - Reserve some third-party API messages to debug logging (#10, #29)
  - Set the priority of external thumbnailers to 0
  - Revert "Set Max file sizes."
  - xdg-cache: Add missing sanity check
  - xdg-cache: Remove temporary file when saving failed
  - xdg-cache: Set thumbnail permissions to 600
  - pixbuf-thumbnailer: Try to ignore `GDK_PIXBUF_ERROR_CORRUPT_IMAGE`
  - Use microsecond precision for last modification time (#15, !20)
  - poppler-thumbnailer: Fix error handling
  - pixbuf-thumbnailer: Simplify error handling
  - font-thumbnailer: Fix error handling
  - Cache cleanup when a request for a URI fails (#22)
  - jpeg-thumbnailer: Do not use low quality embedded thumbnail (#37)
  - gst-thumbnailer: Fix error handling
  - ffmpeg-thumbnailer: Fix error handling
  - odf-thumbnailer: Fix error handling
  - xdg-cache: Ensure read_thumbnail_info() always sets an error on failure
  - xdg-cache: Chain-up to parent in `finalize()`
  - desktop-thumbnailer: Fill in `finalize()`
  - gepub-thumbnailer: Fix a memory leak
  - desktop-thumbnailer: Fix some memory leaks
  - desktop-thumbnailer: Fix error handling
  - Fix some priority issues
  - pixbuf-thumbnailer: Use a mime-type-specific loader when possible (#20, #32, #36, !18)
  - raw-thumbnailer: Check for all possible pkg-config files (#44, !18)

- Translation Updates:
  Albanian, Arabic, Armenian (Armenia), Basque, Belarusian, Bengali,
  Bulgarian, Catalan, Chinese (China), Chinese (Hong Kong), Chinese
  (Taiwan), Croatian, Czech, Danish, Dutch, Eastern Armenian, English
  (Australia), English (United Kingdom), Estonian, Finnish, French,
  Galician, German, Greek, Hebrew, Hindi, Hungarian, Icelandic,
  Indonesian, Italian, Japanese, Kabyle, Kazakh, Korean, Lithuanian,
  Malay, Norwegian Bokmål, Norwegian Nynorsk, Occitan (post 1500),
  Polish, Portuguese, Portuguese (Brazil), Romanian, Russian, Serbian,
  Slovak, Slovenian, Spanish, Swedish, Thai, Turkish, Ukrainian, Uyghur

4.16.0 (2020-12-23)
======
- Remove GLIB_CHECK_VERSION IFDEFs which are obsolete after glib bump
- bump glib (and gio, gthread, etc) minimum to 2.50.0
- Adjust bug report URL
- Translation Updates:
  Estonian, Turkish

0.3.1 (2020-11-15)
=====
- New plugin, libgepub thumbnailer plugin
- Fix documentation URL
- Add README.md and EXTRA_DIST
- Add new icon needed for xfce4-about-dialog
- Translation Updates: lt, oc, he, hi, hu, sk, tr, ug

0.3.0 (2020-08-13)
=====
- Fix jpeg thumbnail orientation when fallback code is taken place (Bug #28).
- Use AC_CONFIG_MACRO_DIRS instead of AC_CONFIG_MACRO_DIR
- Fix GTimeVal deprecation
- Drop support of GLib < 2.32
- Use guint32 for request handle and fix its further occurrences of 0
- Implement Excludes paths in tumbler.rc
- Translation Updates: be, da, el, es, he, hu, hye, it, nl, pl, sq, zh_TW, zh_HK

0.2.8 (2019-12-21)
======
- Fix thumbnail orientation (Bug #15011)
- prepend $XDG_DATA_HOME/thumbnailers/ to thumbnailers directory (Bug #15858)
- Translation Updates: Galician, Portuguese, Slovenian, Spanish

0.2.7 (2019-08-12)
======
- Translation Updates: Galician

0.2.6 (2019-07-28)
======
- Translation Updates: Finnish, Norwegian Bokmål

0.2.5 (2019-06-30)
=====
- Translation Updates: Armenian, Danish

0.2.4 (2019-05-17)
=====
- Check for sparse video files only on plugin side
- Set Max file sizes
- Add Fujifilm RAF support (Bug #14522)
- Add more media types for audio cover thumbnails (Bug #12041)
- Fix a typo in desktop-thumbnailer-provider.c (Bug #14925)
- Update URLs in README and configure.ac
- Fix g_type_class_add_private is deprecated
- Bump glib version
- Translation Updates: Albanian, Basque, Belarusian, Catalan, Dutch (Flemish),
  Finnish, French, Galician, Hebrew, Italian, Kazakh, Lithuanian, Polish,
  Portuguese (Brazilian), Romanian, Russian, Slovak, Swedish, Ukrainian

0.2.3 (2018-09-13)
=====
- Test sparse files only for regular files (bug #14693).
- Fix uninitialized variable (bug #14688)

0.2.2 (2018-09-08)
=====
- Added check to avoid sparse files, that cause high cpu and
  memory load. (bug #12259).
- Use hash table to avoid scanning xdg user path twice when
  searching for desktop thumbnailers.
- Close desktop thumbnailers directory when done from it.
- Accept network paths in ffmpeg thumbnailer plugin.
- Use pkg-config to find FreeType > 2.9.1.
- Translation Updates: Czech, Finnish, Hungarian, Italian,
  Greek and English (Australia).

0.2.1 (2018-03-31)
=====
- #9231 Handle 0 mtime threshold on Cleanup DBus method. This fixes
  running across all thumbnails that was causing very high I/O bandwidth 
  usage when a file with a thumbnail gets deleted. (On dbus Cleanup method).

0.2.0 (2017-07-17)
=====
- Stable release of tumbler ported to GDbus, in addition
  also fixes the bugs fixed by the version 0.1.32.
- #13618 avoid loading specialized tumbnailers twice on system with
  duplication path entry in $XDG_DATA_HOME (causes assertion failure)
- #13360 don't close GdkPixbufLoader on error (causes sigabrt)
- #13240 fix typo in exif tag for image height
- #13201 fix finding of libopenraw-0.1.0

0.1.92.1 (2017-05-28)
========
- Fixe missing entry of the new desktop thumbnailer plugin
  in tumbler.rc.

0.1.92 (2017-05-28)
======
- Add support for loading thumbnailers from *.thumbnailer files 
  (enhancement bug #7475)

0.1.90 (2017-05-11)
======
- Tumbler relies now on gdbus instead of dbus-glib

0.1.31 (2015-02-28)
======
- Use $XDG_CACHE_HOME/thumbnails as per spec change (bug #10613)
- Move xdt m4 macros into separate directory
- Update xdt m4 macros
- Bump autotools requirements
- Fix IT_PROG_INTLTOOL warning
- Fix all m4 warnings
- Enable support for video/webm in ffmpeg thumbnailer plugin (bug #10360)
- Translation updates: Asturian, Bulgarian, Croatian, French, German,
  Greek, Norwegian Bokmål, Polish, Romanian, Slovak, Spanish

0.1.30 (2014-02-23)
======
- Only enable keepalive in curl >= 7.25.
- Support move/copy operations on directories in the cache.
- Send the cache operation replies after they are completed.
- Translation updates: Arabic, Asturian, Bulgarian, Bengali, Catalan
  (Valencian), Czech, Danish, German, Greek, English (Australia),
  English (United Kingdom), Spanish (Castilian), Basque, Finnish,
  French, Galician, Hebrew, Hungarian, Indonesian, Italian, Japanese,
  Kazakh, Korean, Lithuanian, Latvian, Malay, Norwegian Bokmal, Dutch
  (Flemish), Norwegian Nynorsk, Occitan (post 1500), Polish,
  Portuguese, Portuguese (Brazilian), Romanian, Russian, Slovak,
  Swedish, Thai, Turkish, Uyghur, Ukrainian, Chinese (China), Chinese
  (Hong Kong), Chinese (Taiwan).

0.1.29 (2013-05-05)
======
- Fix memory corruption on 64bit (bug #9766).
- Translation updates: Japanese, Dutch (Flemish), Serbian.

0.1.28 (2013-05-05)
======
- Set nice value of tumblerd to 19 (bug #9627).
- Fix rendering from pdfs with thumbnail (bug #9972).
- Add more supported types for gst thumbnailer (bug #9747).
- Some additional debug checks for bug #9766 and minor optimizations.
- Fix deprecating warning with glib 2.36.
- Include string.h (bug #9858).
- Translation updates: Arabic, Bulgarian, Czech, Spanish (Castilian),
  Basque, French, Hungarian, Indonesian, Italian, Japanese, Kazakh,
  Korean, Dutch (Flemish), Polish, Portuguese, Portuguese (Brazilian),
  Romanian, Russian, Serbian, Swedish, Uyghur, Ukrainian, Chinese
  (China), Chinese (Taiwan).

0.1.27 (2013-01-12)
======
- Autotools updates.
- Remove unmaintained translations.
- Fix build when using -Wl,-z,defs
- Add cover-thumbnailer for movies.
- Add config file system to control thumbnailing plugins.
- Release thumbnail in gst thumbnailer.

0.1.26 (2012-12-09)
======
- Remove INSTALL
- Directly render the capture in the correct size.
- New gstreamer thumbnailer based on totem-thumbnailer.
- Disable http and cdda schemes as well.
- Add support for MPEG2 transport streams (bug #7421).
- Rotate jpeg thumbnails (bug #6730).
- Plug small leak.
- Don't use collate to check strings.
- Release lifecycle manager during early exit.
- Don't abort with warnings in debug mode.
- Clear 2.32 mutex memory leak.
- Drop unneeded vfs schemes.
- Work with an array to store the strings.
- Don't use GString for a simple concat.
- Make registry dump a bit smaller.
- Don't use deprecated glib 2.32 API.
- Rotate pixbuf loader images (bug #6730).
- Translation updates: Arabic, Spanish (Castilian), Icelandic,
  Korean, Dutch (Flemish), Serbian, Uyghur.

0.1.25 (2012-04-28)
======
- Remove some unused m4 macros.
- Add or fix missing licenses.
- Translation updates: Greek, English (United Kingdom), Galician,
  Japanese, Kazakh, Korean, Dutch (Flemish), Polish, Portuguese,
  Portuguese (Brazilian), Romanian, Chinese (China).

0.1.24 (2012-03-28)
======
- Update COPYING to the latest version of GPL2 (bug #7796).
- Link all plugins that use rint() against libm (bug #8236).
- Call dbus_g_thread_init() to fix threading issues (bug #7544).
- Add application/vnd.rn-realmedia to the ffmpeg plugin (bug #6949).
- Explicitly link against gmodule (bug #8466).
- Avoid accessing list elements after they have been freed (bug #7418).
- Make sure to include PLATFORM flags everywhere.
- Translation updates: bg, ca, cs, de, es, fi, he, id, is, kk, ko, lt,
  nn, pl, pt, pt_BR, zh_CN.

0.1.23 (2011-12-04)
======
- Fix generation of video images by starting the pipeline (bug #7996).
- Fix ownership race conditions when started twice (bug #8001).
- Add an ODF thumbnailer plugin.
- Add support for OpenRaster images in the ODF thumbnailer (bug #6108).
- Add a raw image thumbnailer plugin.
- Drop AC_PROG_LIBTOOL in favor of LT_PREREQ and LT_INIT.
- Don't crash on 0x0 errors (bug #8142).
- Exit the xdg thumbnailer nicely with corrupt png files.
- Avoid huge thumbnails from libjpeg (bug #8020).
- Optimize the pixbuf thumbnailer.
- Translation updates: Icelandic, Turkish, Malay, Hungarian, Korean,
  Chinese (Taiwan), Arabic, Danish, Slovak, Ukrainian, Russian,
  Italian, Japanese, Portuguese (Brazilian), Basque, Hungarian,
  Dutch (Flemish), Chinese (China), French.

0.1.22 (2011-09-21)
======
- Add coding style documentation.
- Fix compiler error on Sun Studio.
- Add a GStreamer-based thumbnailer for video thumbnails. Thanks to
  Ross Burton for the work.
- Avoid GdkPixbuf functions deprecated in poppler >= 0.17 (bug #7649).
- Translation updates: Arabic, Basque, Catalan (Valencian),
  Chinese (China), Chinese (Taiwan), Danish, Dutch (Flemish), Finnish,
  French, German, Indonesian, Italian, Japanese, Kazakh, Korean,
  Portuguese (Brazilian), Portuguese, Romanian, Russian, Slovak,
  Spanish (Castilian), Swedish, Telugu, Turkish, Ukrainian.

0.1.21 (2011-02-14)
======
- Update to latest revision of the thumbnail management D-Bus
  specification where Cleanup() takes an array of base URIs instead
  of just one.
- Get rid of the inherently broken GStrv type in function signatures.
- Quit tumbler after at least 5 minutes of inactivity.

0.1.20 (2011-02-12)
======
- Version bump to override incompatibly versioned packages for Maemo.
- Translation updates: Swedish.

0.1.6 (2011-01-16)
=====
- Fix a possible segmentation fault in the JPEG thumbnailer plugin.
- Translation updates: Arabic, Chinese (Taiwan), Czech, English (United
  Kingdom), Finnish, French, Galician, Greek, Hebrew, Indonesian,
  Japanese, Norwegian Bokmal, Polish, Romanian, Russian, Ukrainian.

0.1.5 (2010-12-05)
=====
- Fix a segmentation fault when one of the thumbnailer directories is
  deleted (bug #6134).
- Fix sched_getparam/sched_setscheduler code on OpenBSD (bug #6061).
- Fix init/shutdown debug message in the JPEG thumbnailer plugin.
- Translation updates: Hungarian, Portuguese (Brazilian), German,
  Chinese (China), Catalan (Valencian), Italian, Basque, Kazakh,
  Portuguese, Danish.

0.1.4 (2010-11-07)
=====
- Use LGPL instead of GPL license headers in the library (bug #6781).

0.1.3 (2010-11-03)
=====
- Link plugins against libtumbler-1. Should fix builds with
  --as-needed.
- Move tumblerd into $libdir/tumbler-1.
- Add support for arbitrary URI shemes in the poppler plugin.
- Translation updates: Basque, Indonesian, Swedish, German, Russian,
  Galician, Uyghur, Chinese (Taiwan), Ukrainian, Finnish, Catalan
  (Valencian), Danish, Japanese, Kazakh, Italian, Portuguese,

0.1.2 (2010-07-16)
=====
- Add a new PDF/PostScript thumbnailer plugin based on poppler.
- Add a new video thumbnailer plugin using libffmpegthumbnailer.
- Handle missing URIs/MIME types in thumbnailer requests by reporting
  them back to the client application as an error.
- Don't use dbus_connection_send from threads. Use g_idle_add()
  instead.
- Improve tumblerd's startup significantly by optimizing the code
  dealing with updating the supported URI schemes and MIME types.
- Avoid compiler warnings due to global name shadowing.
- Translation updates: Traditional Chinese, Punjabi, Bengali, Sinhala,
  French, Chinese (China) and more.

0.1.1 (2010-01-07)
=====
- New fast JPEG thumbnailer with EXIF support
- Report unsupported flavors back to clients via error signals
- Translation updates: Swedish, Catalan, Galician, Japanese, Danish,
  Portuguese, Chinese

0.1.0 (2009-12-07)
=====
- Initial release
